---
title: AbstractWorker
slug: Web/API/AbstractWorker
tags:
  - API
  - Abstract
  - AbstractWorker
  - Interface
  - Reference
  - SharedWorker
  - Web Workers
  - Web Workers API
  - Worker
---
<div>{{ APIRef("Web Workers API") }}</div>

<p><span class="seoSummary">The <strong><code>AbstractWorker</code></strong> interface of the <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers API</a> is an abstract interface that defines properties and methods that are common to all types of worker, including not only the basic {{domxref("Worker")}}, but also {{domxref("ServiceWorker")}} and {{domxref("SharedWorker")}}.</span> As an abstract class, you don't directly interact with <code>AbstractWorker</code>.</p>

<h2 id="Properties">Properties</h2>

<p><em>The <code>AbstractWorker</code></em><em> interface doesn't inherit any properties.</em></p>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("AbstractWorker.onerror")}}</dt>
 <dd>An {{ domxref("EventListener") }} which is invoked whenever an {{domxref("ErrorEvent")}} of type <code>error</code> bubbles through the worker.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The <code>AbstractWorker</code></em><em> interface doesn't implement or inherit any methods.</em></p>

<h2 id="Example">Example</h2>

<p>As an abstract interface, you won't directly use <code>AbstractWorker</code> in your code. Instead, you'll interact with either {{domxref("Worker")}} or {{domxref("SharedWorker")}}, both of which inherit the properties of <code>AbstractWorker</code>.</p>

<p>This code snippet demonstrates the creation of a new <code>Worker</code> using the {{domxref("Worker.Worker", "Worker()")}} constructor; it also shows how to then send a message to the worker.</p>

<pre class="brush: js notranslate">var myWorker = new Worker('worker.js');

first.onchange = function() {
  myWorker.postMessage([first.value, second.value]);
  console.log('Message posted to worker');
}</pre>

<p>The worker's code is loaded from the file <code>"worker.js"</code>. This code assumes that there's an {{HTMLElement("input")}} element represented by <code>first</code>; an event handler for the {{event("change")}} event is established so that when the user changes the value of <code>first</code>, a message is posted to the worker to let it know.</p>

<p>You can find more examples on the MDN Web Docs GitHub repository:</p>

<ul>
 <li><a class="external external-icon" href="https://github.com/mdn/simple-web-worker">Basic dedicated worker example</a> (<a class="external external-icon" href="https://mdn.github.io/simple-web-worker/">run dedicated worker</a>).</li>
 <li><a class="external external-icon" href="https://github.com/mdn/simple-shared-worker">Basic shared worker example</a> (<a class="external external-icon" href="https://mdn.github.io/simple-shared-worker/">run shared worker</a>).</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#abstractworker", "AbstractWorker")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>No change from {{SpecName("Web Workers")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AbstractWorker")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("Worker")}}, {{domxref("ServiceWorker")}}, and {{domxref("SharedWorker")}} interfaces, which are all based upon <code>AbstractWorker</code>.</li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers API</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">Using Web Workers</a></li>
</ul>
